<template>
  <section>
    <loading :active.sync="loading" :is-full-page="fullPage" />
    <h2>Synthèse</h2>
    <hr>
    <template v-if="synthesis">
      <h3>Estimation du total des rentes mensuelles et capitaux vieillesse, sans changement de situation, à l’âge de la retraite légale</h3>
      <p>
        Date de versement de la rente: {{synthesis.date.value}}
        <SynthesisMeta :meta="synthesis.date.meta" />
      </p>

      <h4>Rentes vieillesse :</h4>
      <p>Rente 1er pilier : CHF {{synthesis['annuities']['1_pillar'].value ? synthesis['annuities']['1_pillar'].value.toFixed(2) : 0}}<SynthesisMeta :meta="synthesis['annuities']['1_pillar'].meta" /><br/>
        Rente 2ème pilier :  CHF {{synthesis['annuities']['2_pillar'].value ? synthesis['annuities']['2_pillar'].value.toFixed(2) : 0}}<SynthesisMeta :meta="synthesis['annuities']['2_pillar'].meta" /><br/>
        <strong>Total des rentes vieillesse :</strong>   CHF {{synthesis['annuities']['total'].value ? synthesis['annuities']['total'].value.toFixed(2) : 0}}<SynthesisMeta :meta="synthesis['annuities']['total'].meta" /></p>

        <h4>Capitaux vieillesse :</h4>
        <p>Capital 2ème pilier : CHF {{synthesis['capitals']['2_pillar'].value ? synthesis['capitals']['2_pillar'].value.toFixed(2) : 0}}<SynthesisMeta :meta="synthesis['capitals']['2_pillar'].meta" /><br/>
          Capital 3ème pilier :  CHF {{synthesis['capitals']['3_pillar'].value ? synthesis['capitals']['3_pillar'].value.toFixed(2) : 0}}<SynthesisMeta :meta="synthesis['capitals']['3_pillar'].meta" /><br/>
          Capital du libre passage : {{synthesis['capitals']['vested_benefits'].value ? synthesis['capitals']['vested_benefits'].value.toFixed(2) : 0}}<SynthesisMeta :meta="synthesis['capitals']['vested_benefits'].meta" /><br/>
          <strong>Total des capitaux :</strong>  CHF {{synthesis['capitals']['total'].value ? synthesis['capitals']['total'].value.toFixed(2) : 0}}<SynthesisMeta :meta="synthesis['capitals']['total'].meta" /></p>
          <hr/>
        </template>
        <template v-if="calculator">
          <h3>Information du 1er pilier</h3>
          <a @click="showCalculator = !showCalculator">Toggle info</a>
          <pre v-if="showCalculator">{{calculator}}</pre>
        </template>
        <template v-if="registry && policies">
          <h3>Vos caisses de prévoyance</h3>
          <ul>
            <li v-for="(policy, policyId) in policies" :id="policyId+openPolicies[policyId]" :key="policyId+openPolicies[policyId]">
              <h4>{{ registry[policyId].name }}</h4>
              <a @click="$set(openPolicies, policyId, !openPolicies[policyId])">Toggle policy</a>
              <template v-if="openPolicies[policyId]">
                <pre>{{ policy }}</pre>
              </template>
            </li>
          </ul>
        </template>
        <template v-if="open3KInfo.solde">
          <h3>Information du 3ème pilier</h3>
          <p>Solde actuel du compte<br/><strong>{{open3KInfo.solde}}</strong></p>
          <p>Montant des cotisations annuelles prévisionnelles<br/><strong>{{open3KInfo.amount}}</strong></p>
          <p>Taux d’intérêt prévisionnel<br/><strong>{{open3KInfo.rate}}</strong>%</p>
          <p>Date souhaitée de versement du capital<br/><strong>{{open3KInfo.paydate}}</strong></p>
        </template>
      </section>
    </template>

    <script>

      import Loading from 'vue-loading-overlay'
      import { mapMutations } from 'vuex'
      import Multiselect from 'vue-multiselect'
      import SynthesisMeta from '/components/synthesis-meta.vue'

      export default {
        components: {
          Loading,
          SynthesisMeta
        },
        data () {
          return {
            fullPage: true,
            isLoading: 1,
            selection: [],
            userSelectedFundIds: [],
            currentSelected: [],
            grantingWindow: null,
            grantingOk: false,
            openPolicies: {},
            showCalculator: false,
            synthesis: null,
            currentIndex: 999,
            nextPath: null,
          }
        },
        computed: {
          loading() {
            return this.isLoading > 0;
          },
          open3KInfo () {
            return this.$store.state.open3k
          },
          registry () {
            return this.$store.state.openpk.registry
          },
          policies () {
            return this.$store.state.openpk.policies
          },
          calculator () {
            return this.$store.state.openak.calculator
          },
          fundSelection () {
            return this.$store.state.user.fundSelection
          }
        },
        mounted () {
          this.$nuxt.$emit('check-if-connected')
          this.$nuxt.$once('user-is-connected', this.init)
        },
        methods: {
          ...mapMutations({
            setCalculator: 'openak/setCalculator',
            setRegistry: 'openpk/setRegistry',
            setPolicies: 'openpk/setPolicies',
            set3KInfo: 'open3k/setInfo',
          }),
          init () {
            this.currentIndex = 999;
            console.log(this.currentIndex);
            if (!this.calculator) {
              this.isLoading++;
              console.log('calculator+');
              this._getPensionCalculator().then((data) => {
                console.log('calculator');
                this.setCalculator(data)
              }).catch(() => {
                this.goTo('/openak', 0);
              }).finally(() => {
                console.log('calculator-');
                this.isLoading--;
              })
            }

            if (!this.registry) {
              console.log('registry+');
              this.isLoading++;
              this._getRegistry().then((data) => {
                this.setRegistry(data)
              }).catch(() => {
                this.goTo('/openpk', 1);
              }).finally(() => {
                console.log('registry-');
                this.isLoading--;
              })
            }

            if (!this.policies) {
              console.log('policies+');
              this.isLoading++;
              this._getPolicies().then((policies) => {
                this.setPolicies(policies);
              }).catch(() => {
                this.goTo('/openpk', 10);
              }).finally(() => {
                console.log('policies-');
                this.isLoading--;
              })
            }

            if (!this.open3KInfo || !this.open3KInfo.solde) {
              console.log('open3KInfo+');
              this.isLoading++;
              this._getOpen3KInfo().then((info) => {
                this.set3KInfo(info);
              }).catch(() => {
                this.goTo('/open3k', 2);
              }).finally(() => {
                console.log('open3KInfo-');
                this.isLoading--;
              })
            }

            this.isLoading++;
            console.log('synthesis+');
            this._getSynthesis().then((synthesis) => {
              this.synthesis = synthesis;
            }).finally(() => {
              console.log('synthesis-');
              this.isLoading--;
            })

            this.isLoading--;
          },
          goTo(nextPath, index) {
            let first = false;
            if (this.currentIndex = 999) {
              first = true;
            }
            if (this.currentIndex > index) {
              this.currentIndex = index;
              this.nextPath = nextPath;
            }
            if (first) {
              setTimeout(this.goNextPath, 500)
            }
          },
          goNextPath() {
                this.$router.push(this.nextPath);
          },
          _getPensionCalculator() {
            return this.$api.get('/openak/pension-calculator')
          },
          _getOpen3KInfo () {
            return this.$api.get('/open3k/info')
          },
          _getPolicies () {
            return this.$api.get('/openpk/user/pension-funds/policies')
          },
          _getRegistry () {
            return this.$api.get('/openpk/pension-funds')
          },
          _getSynthesis () {
            return this.$api.get('/synthesis/digest')
          }
        }
      }
    </script>
    <style>
      .multiselect__input, .multiselect__single {
        border: none !important;
      }
    </style>
